﻿Imports ThinkGeo.UI.WinForms
Imports ThinkGeo.Core
Imports System.Threading
Public Class Form1
  Public MainMap As MapView

  Public Sub New()

    ' This call is required by the designer.
    InitializeComponent()

    ' Add any initialization after the InitializeComponent() call.
    '***** Enable per monitor dpi awareness for Infragistics controls
    '***** For now, this seems to create more problems than it solves.
    '***** SET 05/27/2021
    Infragistics.Win.DpiUtilities.MaxInfragisticsDpiAwareness = Infragistics.Win.InfragisticsDpiAwareness.PerMonitorDpiAware

  End Sub

  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
    MainMap = New MapView()
    'MainMap.Size = New Size(800, 450)
    MainMap.Dock = DockStyle.Fill
    Controls.Add(MainMap)
    Form1_Fill_Panel.SendToBack()
    mAddWmtsLayer()
    'mAddWmsLayer()

  End Sub
  Private Async Sub mAddWmtsLayer()
    Dim oWmtsLayer As New WmtsAsyncLayer()
    With oWmtsLayer
      .WmtsServerEncodingType = WmtsServerEncodingType.Restful
      .ServerUri = New Uri("https://basemap.nationalmap.gov/arcgis/rest/services/USGSImageryOnly/MapServer/WMTS?")
      .ActiveLayerName = ""
      .ActiveStyleName = ""
      .DrawingExceptionMode = DrawingExceptionMode.DrawException
      '.OutputFormat = 
      'Await .OpenAsync()
      Dim oOverlay As New LayerOverlay
      oOverlay.Layers.Add(oWmtsLayer)
      MainMap.Overlays.Add(oOverlay)
      'MainMap.CurrentExtent = 
      Await MainMap.RefreshAsync


    End With
  End Sub
  'Private Async Sub mAddWmsLayer()
  '  ' Create an overlay that we will add the layer to.
  '  Dim staticOverlay As New LayerOverlay()
  '  MainMap.Overlays.Add(staticOverlay)
  '  MainMap.MapUnit = GeographyUnit.DecimalDegree
  '  ' Create the WMS layer using the parameters below.
  '  ' This Is a public service And Is very slow most of the time.
  '  Dim wmsImageLayer As New WmsAsyncLayer(New Uri("http://ows.mundialis.de/services/service"))
  '  'wmsImageLayer.UpperThreshold = double.MaxValue;
  '  'wmsImageLayer.LowerThreshold = 0;
  '  wmsImageLayer.ActiveLayerNames.Add("OSM-WMS")
  '  wmsImageLayer.ActiveStyleNames.Add("default")
  '  wmsImageLayer.Exceptions = "application/vnd.ogc.se_xml"

  '  ' Add the layer to the overlay.
  '  staticOverlay.Layers.Add("wmsImageLayer", wmsImageLayer)

  '  MainMap.CurrentExtent = New RectangleShape(-96.8538765269409, 33.1618647290098, -96.7987487018851, 33.1054126590461)
  '  Await MainMap.RefreshAsync()
  'End Sub
End Class
